/*
 * Copyright (c) 1996-1997, InetSoft Technology Corp, All Rights Reserved.
 *
 * The software and information contained herein are copyrighted and 
 * proprietary to InetSoft Technology Corp. This software is furnished 
 * pursuant to a written license agreement and may be used, copied, 
 * transmitted, and stored only in accordance with the terms of such 
 * license and with the inclusion of the above copyright notice. Please 
 * refer to the file "COPYRIGHT" for further copyright and licensing 
 * information. This software and information or any other copies 
 * thereof may not be provided or otherwise made available to any other 
 * person. 
 */
package itrade.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import tea.set.*;
import bamboo.pipe.*;

class Composition {
   /*
    * GUI components on the panel.
    */
   private Effect3D    graphPanelDecor;
   private Panel       graphPanel;
   private Graph       graph;
   private Label       graphLabel;
   private Node        currentAcct;
   
   Composition(Panel parent) {
      graphPanel = new Panel(new BorderLayout());
      graphPanelDecor = new Effect3D(graphPanel, 
				    "Acct Composition", 
				    Effect3D.LOWERED_BORDER);
      graph = new Graph();
      graphLabel = new Label("Please select an account");
      graphLabel.setAlignment(Label.CENTER);
      graphPanel.add(graphLabel, BorderLayout.NORTH);
      graphPanel.add(graph, BorderLayout.CENTER);
      //graphPanelDecor.setBounds(253, 9, 225, 216);
      parent.add("graphPanelDecor", graphPanelDecor);
      graphPanel.setVisible(false);
   }
   
   void setupData(String label, Node acct, 
		  Vector xData, Vector yData) {
      currentAcct = acct;
      graphLabel.setText(label);
      
      graph.setValues(xData, yData);
      graph.setStyle(Graph.PIE3D);
   }

   String getCurrentAcct() {
      return currentAcct.getPath();
   }
   
   void setVisible(boolean v) {
      graphPanelDecor.setVisible(v);
      graphPanel.setVisible(v);
   }
}
