/*
 * Copyright (c) 1996-1997, InetSoft Technology Corp, All Rights Reserved.
 *
 * The software and information contained herein are copyrighted and 
 * proprietary to InetSoft Technology Corp. This software is furnished 
 * pursuant to a written license agreement and may be used, copied, 
 * transmitted, and stored only in accordance with the terms of such 
 * license and with the inclusion of the above copyright notice. Please 
 * refer to the file "COPYRIGHT" for further copyright and licensing 
 * information. This software and information or any other copies 
 * thereof may not be provided or otherwise made available to any other 
 * person. 
 */
package itrade.gui;

import java.applet.*;
import java.awt.*;
import java.rmi.*;
import java.rmi.server.*;
import java.net.URL;
import java.awt.event.*;
import java.util.Vector;
import tea.set.*;
import bamboo.pipe.*;

public class ITrade extends java.applet.Applet {
   public static Image saveImage;
   public static Image deleteImage;
   public static Image clearImage;
   public static Image stopImage;
   public static Image startImage;
   public static Image blackBallImage;
   public static Image redBallImage;
   public static Image greenDialImage;
   public static Image redDialImage;
   public static Image yellowDialImage;
   public static Image blackDialImage;
   public static Image refreshImage;
   public static Image detailImage;
   public static Image graphicImage;
   private static Applet instance;
   
   private NewsTicker  newsTicker;
   private Trading     trading;
   private Message     message;

   public static void displayStatus(String s) {
      if (instance != null) {
	 instance.showStatus(s);
      }
   }

   public static String findParameter(String s) {
      if (instance != null) {
	 return instance.getParameter(s);
      }
      return null;
   }
   
   public void init() {
      BambooPipe   msgServer;
      
      super.init();

      /*
       * setup the globe service method.
       */
      instance = this;

      setLayout(null);
      setBackground(new java.awt.Color(192, 192, 192));
      setLayout(new BorderLayout());
      //setBounds(9, 27, 897, 943);

      /*
       * find the pipe server.
       */
      try {
         msgServer = (BambooPipe)Naming.lookup("//" +
                        getCodeBase().getHost() + "/" + 
			getParameter("pipeServer"));
      }
      catch(Exception e) {
	 e.printStackTrace();
	 return;
      }
      

      /*
       * get all resource for the applet.
       */
      saveImage = getImage(getCodeBase(), "icon/disk_cat.gif");
      deleteImage = getImage(getCodeBase(), "icon/waste.gif");
      clearImage = getImage(getCodeBase(), "icon/white.gif");
      stopImage = getImage(getCodeBase(), "icon/stop.gif");
      startImage = getImage(getCodeBase(), "icon/start.gif");
      blackBallImage = getImage(getCodeBase(), "icon/blackBall.gif");
      redBallImage = getImage(getCodeBase(), "icon/redBall.gif");
      greenDialImage = getImage(getCodeBase(), "icon/greenDial.gif");
      redDialImage = getImage(getCodeBase(), "icon/redDial.gif");
      yellowDialImage = getImage(getCodeBase(), "icon/yellowDial.gif");
      blackDialImage = getImage(getCodeBase(), "icon/blackDial.gif");
      refreshImage = getImage(getCodeBase(), "icon/refresh.gif");
      detailImage = getImage(getCodeBase(), "icon/view.gif");
      graphicImage = getImage(getCodeBase(), "icon/pie.gif");
      
      /*
       * GUI components are in these three objects.
       */
      trading = new Trading(BorderLayout.CENTER, this, msgServer);
      System.out.println("Between news/trading");
      message = new Message(BorderLayout.SOUTH, this, msgServer);
      System.out.println("Between news/trading");
      newsTicker = new NewsTicker(BorderLayout.NORTH, this, msgServer);
   } /* init */
} /* applet */












