/*
 * Copyright (c) 1996-1997, InetSoft Technology Corp, All Rights Reserved.
 *
 * The software and information contained herein are copyrighted and 
 * proprietary to InetSoft Technology Corp. This software is furnished 
 * pursuant to a written license agreement and may be used, copied, 
 * transmitted, and stored only in accordance with the terms of such 
 * license and with the inclusion of the above copyright notice. Please 
 * refer to the file "COPYRIGHT" for further copyright and licensing 
 * information. This software and information or any other copies 
 * thereof may not be provided or otherwise made available to any other 
 * person. 
 */
package itrade.gui;

import java.awt.*;
import java.awt.event.*;
import tea.set.*;
import bamboo.pipe.*;

class Trading {
   /*
    * GUI Objects on the trading panel.
    */
   public Effect3D     tradingPanelDecor;
   public Panel        tradingPanel;
   public BorderLayout tradingLayout;
   /*
    * GUI components are on these two objects. Position 
    */
   public Editing      editing;
   public Position     position;
   
   Trading(String layoutPos, Panel parent, BambooPipe msgServer) {
      System.out.println("Start trading");
      
      tradingLayout = new BorderLayout();
      tradingPanel = new java.awt.Panel(tradingLayout);
      tradingLayout.setHgap(3);
      
      System.out.println("Between 1");
      
      tradingPanel.setBackground(new java.awt.Color(192, 192, 192));
      tradingPanelDecor = new Effect3D(tradingPanel, "Trading", 
				       Effect3D.RAISED_BORDER);

      parent.add(tradingPanel, layoutPos);
      
      System.out.println("Between trading Panel/Editing");

      editing = new Editing(tradingPanel, msgServer);
      position = new Position(tradingPanel, 
			      new TransSelectAdapter(),
			      new RefreshAdapter(),
			      msgServer);
      
      editing.sendInit();
      return;
   } 

   class TransSelectAdapter implements ItemListener {
      public void itemStateChanged(ItemEvent e) {
	 int      row;
	 String[] posDesc;
	 
	 if (e.getStateChange() != ItemEvent.SELECTED) {
	    return;
	 }
	
	 row = ((Integer)e.getItem()).intValue();
	 
	 posDesc = Tool.tokenize(position.getCurrentPos(), ".");
         System.out.println("currentPos:"+position.getCurrentPos());
         editing.setTrans(posDesc[posDesc.length - 2],
                          posDesc[posDesc.length - 1],
                          position.getObject(row, 1),
	                  position.getObject(row, 2),
	                  position.getObject(row, 3),
	                  position.getObject(row, 4),
	                  position.getObject(row, 5),
	                  position.getObject(row, 6));
      }
   }
   
   class RefreshAdapter implements ActionListener {
      public void actionPerformed(ActionEvent e) {
         editing.sendInit();
      }
   }
}
