/*
 * Copyright (c) 1996-1997, InetSoft Technology Corp, All Rights Reserved.
 *
 * The software and information contained herein are copyrighted and 
 * proprietary to InetSoft Technology Corp. This software is furnished 
 * pursuant to a written license agreement and may be used, copied, 
 * transmitted, and stored only in accordance with the terms of such 
 * license and with the inclusion of the above copyright notice. Please 
 * refer to the file "COPYRIGHT" for further copyright and licensing 
 * information. This software and information or any other copies 
 * thereof may not be provided or otherwise made available to any other 
 * person. 
 */
package itrade.service;

import java.net.*;
import java.rmi.*;
import java.rmi.server.*;
import tea.set.Tool;
import bamboo.pipe.*;

class DBService {
   static Producer          prd;
   static ConsumerConfig    csm;
   static int               newId = 90000;
   
   String[] initPos = {"IS Bank.Trust.453000001~"+
			    "T|10000|AT&T|35.00^"+
			      "ok|15839|Buy|23.00|1000|03/24/85|Initial Buy^"+
			      "ok|16394|Buy|20.00|13000|06/12/87^"+
			      "ok|35495|Sell|30.25|4000|11/05/93",
	                 "IS Bank.Trust.453000102~"+
			    "MWHS|32000|Micro Warehouse|43.00^"+
			      "ok|28239|Buy|10.75|23000|07/16/90|Initial Buy^"+
			      "ok|29345|Sell|15.00|10000|12/09/93^"+
			      "ok|30495|Buy|40.25|19000|11/05/97",
	                 "IS Bank.Trust.453000405~"+
			    "DIS|2000|Walt Disney Co|63.35^"+
			      "ok|10043|Buy|30.75|5000|07/16/92|Initial Buy^"+
			      "ok|22345|Sell|50.30|3000|12/09/95",
	                 "IS Bank.Security Lending.437000405~"+
			    "INGR|40000|Intergraph Corp|16.25^"+
			      "ok|38922|Buy|16.00|40000|07/16/97|Collateral",
	                 "IS Bank.Security Lending.437000467~"+
			    "NOBE|5500|Nordstrom, Inc|40.60^"+
			      "ok|38936|Buy|41.05|40000|07/13/97|Collateral",
	                 "IS Security.Equity.Exchange Trades.100345098~"+
			    "CSC|24000|Computer Science|70.0^"+
			      "ok|38043|Buy|68.75|14000|04/18/97|Initial Buy^"+
			      "ok|38145|Buy|67.30|5000|06/23/97^"+
			      "ok|38243|Buy|69.75|5000|07/07/97~"+
			    "NEIC|400000|North East Insurance|1.0^"+
			      "ok|38078|Buy|2.75|500000|05/27/97|Initial Buy^"+
			      "ok|38141|Sell|1.5|50000|07/02/97^"+
			      "ok|38228|Sell|1|50000|11/09/97",
	                 "IS Security.Equity.Arbitrage.120376438~"+
			    "SB|24000|Salomon Inc|36.0^"+
			      "ok|38037|Buy|45.30|44000|03/24/97~"+
			    "EK|10000|Eastman Kodak|64.65^"+
			      "ok|38141|Buy|70.25|3000|02/02/97^"+
			      "ok|38228|Buy|75.70|7000|07/09/97~"+
			    "AAPL|50000|Apple Computer|15.35^"+
			      "ok|38204|Buy|16.36|10000|04/15/97^"+
			      "ok|38356|Buy|13.56|40000|07/12/97",
	             "IS International LLP.Emerging Market.100345098~"+
			    "TIR|4000|China Tire Holdings Ltd|8.0^"+
			      "ok|23037|Buy|6.30|4000|10/24/95~"+
			    "CHPS|15000|Chips Technologies|10.0^"+
			      "ok|26141|Buy|6.25|5000|08/02/94^"+
			      "ok|38228|Buy|9.70|10000|07/09/97"
   };
   
   public static void main(String argv[]) {
      BambooPipe        pipe;
      DBService         dbs = new DBService();
      
      try {
         pipe = (BambooPipe)Naming.lookup("//" + 
                    InetAddress.getLocalHost().getHostName() + "/pipe");
	 prd = pipe.producerLogin("dbRequest", "dbService", "dbrqtp", 
				  null, true); 
	 csm = pipe.consumerLogin("dbRequest", "dbService", "dbrqtc", 
				  dbs. new DBRqtHandler(), true);
	 csm.readyReceive();
      }
      catch(Exception e) {
	 e.printStackTrace();
	 return;
      }
   }
      
   class DBRqtHandler extends UnicastRemoteObject
      implements ConsumerNotify, java.io.Serializable {
	 
      public DBRqtHandler() throws RemoteException {
	 super();
      }
	 
      public void consumerNotify(Consumer c) throws RemoteException { 
	 String code;
	 Object trans;
         String[] fields;
	 
         try {
	    c.beginTrans();
	    code = (String)c.receiveObj();
	    trans = c.receiveObj();
	    c.commitTrans();
	 }
         catch (Exception e) {
	    e.printStackTrace();
	    return;
	 }
	 
	 if (code.equalsIgnoreCase("DBINIT")) {
	    System.out.println("Start to send init");
	    try {
	       prd.beginTrans();
	       prd.sendObj("initReply");
	       prd.sendObj(initPos);
	       prd.commitTrans();
	    }
	    catch (Exception e) {
	       e.printStackTrace();
	    }
	 }
	 else if (code.equalsIgnoreCase("INSERT")) {
	    System.out.println("Start to send insert");
	    fields = Tool.tokenize((String)trans, "^");
	    try {
	       prd.beginTrans();
	       prd.sendObj("insertReply");
	       prd.sendObj("ok^"+
			   fields[0]+"^"+
			   fields[1]+"^"+
			   newId+"^"+
			   " "+"^"+
			   fields[2]);
	       prd.commitTrans();
	    }
	    catch (Exception e) {
	       e.printStackTrace();
	    }
	 }
	 else if (code.equalsIgnoreCase("UPDATE")) {	    
	    System.out.println("Start to send update");
	    fields = Tool.tokenize((String)trans, "^");	    
	    try {
	       prd.beginTrans();
	       prd.sendObj("updateReply");
	       prd.sendObj("ok^"+
			   fields[0]+"^"+
			   fields[1]+"^"+
			   fields[2]+"^"+
			   " ^ ^ ");
	       prd.commitTrans();
	    }
	    catch (Exception e) {
	       e.printStackTrace();
	    }
	 }	 
         else if (code.equalsIgnoreCase("DELETE")) {	    
	    System.out.println("Start to send delete");
	    fields = Tool.tokenize((String)trans, "^");
	    try {
	       prd.beginTrans();
	       prd.sendObj("deleteReply");
	       prd.sendObj("error^"+
			   fields[0]+"^"+
			   fields[1]+"^"+
			   fields[2]+"^"+
			   "No delete is allowed^"+
			   " ^ ");
	       prd.commitTrans();
	    }
	    catch (Exception e) {
	       e.printStackTrace();
	    }
	 }
	 else {
	    System.out.println("Ignore unknown code:"+code);	    
	 }
      }
   }
}






